;  

;   flo
;0  -   
;1  -   .    
;2  -    HL1
;3  -    . 
;4  -    
;5  -  
;6  -  
;7  -  

.INCLUDE	"m8535def.inc"
.DEF	tm1=r2
.DEF	EEBT=r4
.DEF	EEAH=r5
.DEF	store=r6

.DEF	sek1=r8   ;   
;.DEF	regim=r15	;   . .
.DEF	flag1=r16 	; 
.DEF	flag2=r17	; 
.DEF	flag3=r18 	; 
.DEF	flo=r19		; 
.DEF	flam1=r20	; 	
.DEF	flam2=r21   ; 	
.DEF	flam3=r22   ; 
.DEF	DEKR=r23	; 

.DEF	SSREG=r24	;  SREG
.DEF	DEKR1=r25	; 
.DEF	DEKR2=r26	; 
.DEF	tec1=r27
.DEF	DEKR3=r28	; 
.equ	RAM=$060
.equ	adres=$100

.eseg
.org   0x08

.CSEG
.ORG	0
		rjmp Reset
		nop
		nop
		nop
		nop
		nop	
		nop
		nop
		nop
		rjmp TIM0_OVF 
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		 
Reset:	ldi	r30,HIGH(RAMEND)
		out	SPH,r30
		ldi	r30,LOW(RAMEND)
		out	SPL,r30
		ldi	DEKR,4
		ldi	DEKR1,255        ;  255
		ldi	DEKR2,10
		ldi	DEKR3,10
		ldi tec1,255
		mov sek1,tec1      ;  255


		clr	flo
		SBR flo,0b01000101
		CBR flo,0b00010000
		CBR  flam1,0b11111111 ;
		CBR  flam2,0b11111111 
		CBR  flam3,0b11111111 		
		ldi	r30,0b00000000		;      B  D
		out	DDRB,r30
		ldi	r30,$FF		
		out	PORTB,r30
		out PORTD,r30
		ldi	r30,0b11100111	
		out DDRD,r30
							;     

		ldi	r30,0b00000000
		out	DDRC,r30
		ldi	r30,$FF	
		out	PORTC,r30
		ldi r30,0b11111111	;     A	;	
		out PORTA,r30
		ldi	r30,0b00000000
		out DDRA,r30
		clr r30

		out	TCCR0,r30
		ldi r30,1<<TOIE0		
		out	TIMSK,r30
		
	;	ldi r30,1<<TOV0		
	;	out TIFR,r30
		ldi r30,$ff-20
		out TCNT0,r30

		ldi	r30,$03			
		out	TCCR0,r30

		sbi  PORTD,0
		sbi  PORTD,1
		sbi  PORTD,2
		sei

; 
	
SE1:	nop
		rjmp SE1

TIM0_OVF: 
		in	SSREG,SREG 	; 
		
SG0:	dec  sek1			;   
		brne SAL00  ;(SAL0)
		ldi tec1,255
		mov sek1,tec1

		sbic PORTD,7		;  VT3
		rjmp DAL1
		sbi  PORTD,7
		rjmp DAL2
DAL1:	cbi  PORTD,7
DAL2:	
		sbrc flo,2			;    HL1
		rjmp DAL4

		sbic PORTD,2		; HL1
		rjmp DAL3
		sbi  PORTD,2
		rjmp DAL4
DAL3:	cbi  PORTD,2
DAL4:	
		sbic PORTD,3       ; :    ? 
		rjmp SAV0

		DEC  DEKR3			;   
		TST  DEKR3
		brne SLEV
		ldi  DEKR3,10
		CBR  flo,0b00000100 ;    HL1
		rjmp SLEV

SAL00:  rjmp SAL0


SAV0:   SBR  flo,0b00010100 ; 
		sbi  PORTD,0
		sbi  PORTD,1
		sbi  PORTD,2

SLEV:	sbrc flAM1,0
		rjmp SLEK
		sbrc flAM1,1
		rjmp SLEK
		sbrc flAM1,2
		rjmp SLEK
		sbrc flAM1,3
		rjmp SLEK
		sbrc flAM1,4
		rjmp SLEK
		sbrc flAM1,5
		rjmp SLEK
	    sbrc flAM1,6
		rjmp SLEK
	    sbrc flAM1,7
		rjmp SLEK
		sbrc flAM2,0
		rjmp SLEK
		sbrc flAM2,1
		rjmp SLEK
		sbrc flAM2,2
		rjmp SLEK
		sbrc flAM2,3
		rjmp SLEK
		sbrc flAM2,4
		rjmp SLEK
		sbrc flAM2,5
		rjmp SLEK
	    sbrc flAM2,6
		rjmp SLEK
	    sbrc flAM2,7
		rjmp SLEK
		sbrc flAM3,0
		rjmp SLEK
		sbrc flAM3,1
		rjmp SLEK
		sbrc flAM3,2
		rjmp SLEK
		sbrc flAM3,3
		rjmp SLEK
		sbrc flAM3,4
		rjmp SLEK
		sbrc flAM3,5
		rjmp SLEK
	    sbrc flAM3,6
		rjmp SLEK
	    sbrc flAM3,7
		rjmp SLEK
		rjmp SAL0

SLEK:   DEC  DEKR
		TST  DEKR
		brne SL2
		ldi  DEKR,4
		CBR  flam1,0b11111111 ;
		CBR  flam2,0b11111111 
		CBR  flam3,0b11111111 
		sbi  PORTD,1		  ; 
		rjmp SAL0

SL2:	sbic PORTD,4		; ?
		rjmp SAL0

		sbic PORTD,1		; 
		rjmp DAL6
		sbi  PORTD,1
		rjmp SAL0
DAL6:	cbi  PORTD,1
	
SAL0:	SBR  flo,0b00000010 ;     

; B;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		sbic PORTB,0		;
		rjmp SAM1
		CBR  flo,0b00000010
		sbrc flag1,0
		rjmp kAs21
		SBR  flag1,0b00000001
		SBR  flam1,0b00000001
		rjmp kas21
SAM1:	CBR  flag1,0b00000001

kas21:	sbic PORTB,1		;
		rjmp SAM2
		CBR  flo,0b00000010
		sbrc flag1,1
		rjmp SA3
		SBR  flag1,0b00000010
		SBR  flam1,0b00000010
		rjmp SA3
SAM2:	CBR  flag1,0b00000010

SA3:	sbic PORTB,2		;
		rjmp SAM3
		CBR  flo,0b00000010
		sbrc flag1,2
		rjmp SA4
		SBR  flag1,0b00000100
		SBR  flam1,0b00000100
		rjmp SA4
SAM3:	CBR  flag1,0b00000100

SA4:	sbic PORTB,3		;
		rjmp SAM4
		CBR  flo,0b00000010
		sbrc flag1,3
		rjmp SA5
		SBR  flag1,0b00001000
		SBR  flam1,0b00001000
		rjmp SA5
SAM4:	CBR  flag1,0b00001000

SA5:	sbic PORTB,4		;
		rjmp SAM5
		CBR  flo,0b00000010
		sbrc flag1,4
		rjmp SA6
		SBR  flag1,0b00010000
		SBR  flam1,0b00010000
		rjmp SA6
SAM5:	CBR  flag1,0b00010000

SA6:	sbic PORTB,5		;
		rjmp SAM6
		CBR  flo,0b00000010
		sbrc flag1,5
		rjmp SA7
		SBR  flag1,0b00100000
		SBR  flam1,0b00100000
		rjmp SA7
SAM6:	CBR  flag1,0b00100000

SA7:	sbic PORTB,6		;
		rjmp SAM7
		CBR  flo,0b00000010
		sbrc flag1,6
		rjmp SA8
		SBR  flag1,0b01000000
		SBR  flam1,0b01000000
		rjmp SA8
SAM7:	CBR  flag1,0b01000000

SA8:	sbic PORTB,7		;
		rjmp SAM8
		CBR  flo,0b00000010
		sbrc flag1,7
		rjmp SAA1
		SBR  flag1,0b10000000
		SBR  flam1,0b10000000
		rjmp SAA1
SAM8:	CBR  flag1,0b10000000

; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SAA1:	sbic PORTA,0		;
		rjmp SAMA1
		CBR  flo,0b00000010
		sbrc flag2,0
		rjmp SAA2
		SBR  flag2,0b00000001
		SBR  flam2,0b00000001
		rjmp SAA2
SAMA1:	CBR  flag2,0b00000001

SAA2:	sbic PORTA,1		;
		rjmp SAMA2
		CBR  flo,0b00000010
		sbrc flag2,1
		rjmp SA3
		SBR  flag2,0b00000010
		SBR  flam2,0b00000010
		rjmp SAA3
SAMA2:	CBR  flag2,0b00000010

SAA3:	sbic PORTA,2		;
		rjmp SAMA3
		CBR  flo,0b00000010
		sbrc flag2,2
		rjmp SAA4
		SBR  flag2,0b00000100
		SBR  flam2,0b00000100
		rjmp SAA4
SAMA3:	CBR  flag2,0b00000100

SAA4:	sbic PORTA,3		;
		rjmp SAMA4
		CBR  flo,0b00000010
		sbrc flag2,3
		rjmp SAA5
		SBR  flag2,0b00001000
		SBR  flam2,0b00001000
		rjmp SAA5
SAMA4:	CBR  flag2,0b00001000

SAA5:	sbic PORTA,4		;
		rjmp SAMA5
		CBR  flo,0b00000010
		sbrc flag2,4
		rjmp SAA6
		SBR  flag2,0b00010000
		SBR  flam2,0b00010000
		rjmp SAA6
SAMA5:	CBR  flag2,0b00010000

SAA6:	sbic PORTA,5		;
		rjmp SAMA6
		CBR  flo,0b00000010
		sbrc flag2,5
		rjmp SAA7
		SBR  flag2,0b00100000
		SBR  flam2,0b00100000
		rjmp SAA7
SAMA6:	CBR  flag2,0b00100000

SAA7:	sbic PORTA,6		;
		rjmp SAMA7
		CBR  flo,0b00000010
		sbrc flag2,6
		rjmp SAA8
		SBR  flag2,0b01000000
		SBR  flam2,0b01000000
		rjmp SAA8
SAMA7:	CBR  flag2,0b01000000

SAA8:	sbic PORTA,7		;
		rjmp SAMA8
		CBR  flo,0b00000010
		sbrc flag2,7
		rjmp SACC1
		SBR  flag2,0b10000000
		SBR  flam2,0b10000000
		rjmp SACC1
SAMA8:	CBR  flag2,0b10000000

; C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SACC1:	sbic PORTC,0		;
		rjmp SAMC1
		CBR  flo,0b00000010
		sbrc flag3,0
		rjmp SAC2
		SBR  flag3,0b00000001
		SBR  flam3,0b00000001
		rjmp SAC2
SAMC1:	CBR  flag3,0b00000001

SAC2:	sbic PORTC,1		;
		rjmp SAMC2
		CBR  flo,0b00000010
		sbrc flag3,1
		rjmp SAC3
		SBR  flag3,0b00000010
		SBR  flam3,0b00000010
 		rjmp SAC3        
SAMC2:	CBR  flag3,0b00000010

SAC3:	sbic PORTC,2		;
		rjmp SAMC3
		CBR  flo,0b00000010
		sbrc flag3,2
		rjmp SAC4
		SBR  flag3,0b00000100
		SBR  flam3,0b00000100

SAMC3:	CBR  flag3,0b00000100

SAC4:	sbic PORTC,3		;
		rjmp SAMC4
		CBR  flo,0b00000010
		sbrc flag3,3
		rjmp SAC5
		SBR  flag3,0b00001000
		SBR  flam3,0b00001000
		rjmp SAC5
SAMC4:	CBR  flag3,0b00001000

SAC5:	sbic PORTC,4		;
		rjmp SAMC5
		CBR  flo,0b00000010
		sbrc flag3,4
		rjmp SAC6
		SBR  flag3,0b00010000
		SBR  flam3,0b00010000
		rjmp SAC6
SAMC5:	CBR  flag3,0b00010000

SAC6:	sbic PORTC,5		;
		rjmp SAMC6
		CBR  flo,0b00000010
		sbrc flag3,5
		rjmp SAC7
		SBR  flag3,0b00100000
		SBR  flam3,0b00100000
		rjmp SAC7
SAMC6:	CBR  flag3,0b00100000

SAC7:	sbic PORTC,6		;
		rjmp SAMC7
		CBR  flo,0b00000010
		sbrc flag3,6
		rjmp SAC8
		SBR  flag3,0b01000000
		SBR  flam3,0b01000000
		rjmp SAC8
SAMC7:	CBR  flag3,0b01000000

SAC8:	sbic PORTC,7		;
		rjmp SAMC8
		CBR  flo,0b00000010
		sbrc flag3,7
		rjmp SA10
		SBR  flag3,0b10000000
		SBR  flam3,0b10000000
		rjmp SA10
SAMC8:	CBR  flag3,0b10000000

SA10:	sbrc flo,2			;    HL1
		rjmp SA11
		sbrc flo,4			;    
		rjmp SA15
		rjmp SWO1
SA15:   sbrc flo,1			;     
		rjmp SAK1

SWO1:	sbic PORTD,3
		rjmp SAK1

		DEC  DEKR1
		TST  DEKR1
		brne SA11
		ldi  DEKR1,255
			
		sbrc flo,3			;    
		rjmp SWO2

		sbic PORTD,1		; 
		rjmp DAK1
		sbi  PORTD,1
		rjmp DAK2
DAK1:	cbi  PORTD,1
DAK2:	cbi  PORTD,0		; 

SWO2:	DEC  DEKR2
		TST  DEKR2
		brne SA11
		ldi  DEKR2,10
		CBR  flo,0b00011000
		rjmp SA11

SAK1:	SBR  flo,0b00001000
	
SA11:	ldi r30,$ff-20
		out TCNT0,r30
		out SREG,SSREG	
		reti		
.EXIT
